#pragma once
#ifndef __Canvas_H__
#define __Canvas_H__

class Canvas
{
public:
	Canvas(Vector2n Position, bool Centered);
	~Canvas();
	
	void MoveView(uint8 Degree, double MoveAmount, double A[2] = 0);
	void RenderBackground();
	void SetupTransform();
	void EndTransform();
	const bool GlobalIsInsideCanvas(const Vector2d Position) const;
	const Vector2d GlobalToCanvas(const Vector2d Position) const;
	void SetDimensions(Vector2n Dimensions);

private:
	Canvas(const Canvas &);
	Canvas & operator =(const Canvas &);

	Vector2d Camera;
	double CameraZ;

	Vector2n	m_Position;
	Vector2n	m_Dimensions;
	bool		m_Centered;
};

#endif // __Canvas_H__
