#pragma once
#ifndef __Main_H__
#define __Main_H__

#if defined(_MSC_VER)
#	pragma warning( disable : 4351 )
#endif

#include <iostream>
#include <fstream>
#include <sstream>
#include <set>
#include <map>
#include <list>
#define _USE_MATH_DEFINES
#include <cmath>
#include <string>
#include <vector>
#include <cassert>
#include <stdio.h>
#include <string.h>
#include <array>

#ifdef WIN32
#define WIN32_LEAN_AND_MEAN
#include <Windows.h>		// Needed for creating a process to compile projects
#endif // WIN32

#include <GL/glfw.h>

#ifdef WIN32
	typedef signed __int8		sint8;
	typedef signed __int16		sint16;
	typedef signed __int32		sint32;
	typedef signed __int64		sint64;
	typedef unsigned __int8		uint8;
	typedef unsigned __int16	uint16;
	typedef unsigned __int32	uint32;
	typedef unsigned __int64	uint64;
//#elif defined(__APPLE__) && defined(__MACH__)
#else		// For __APPLE__ and Linux
/*	typedef signed char			sint8;
	typedef signed short		sint16;
	typedef signed int			sint32;
	typedef signed long long	sint64;
	typedef unsigned char		uint8;
	typedef unsigned short		uint16;
	typedef unsigned int		uint32;
	typedef unsigned long long	uint64;*/
	typedef int8_t				sint8;
	typedef int16_t				sint16;
	typedef int32_t				sint32;
	typedef int64_t				sint64;
	typedef uint8_t				uint8;
	typedef uint16_t			uint16;
	typedef uint32_t			uint32;
	typedef uint64_t			uint64;
#endif // WIN32

using std::endl;

class Concept;
class Project;

class InputManager;
class InputListener;
class SystemInputListener;
class ControlModuleMapping;
class ControlModule;
class UnrealCameraModule;
class TypingModule;
class WidgetModule;
class WidgetManager;
class Widget;
class ButtonWidget;
class TextFieldWidget;
class ListWidget;
class OpenGLStream;
class Canvas;
class Screen;

#include "Vector2.h"

#include "ogl_utils.h"

typedef std::vector<Concept>::size_type ConceptId;

#include "OpenGLStream.h"
#include "Concept.h"
#include "Project.h"
#include "Input/InputManager.h"
#include "Input/InputListener.h"
#include "Input/SystemInputListener.h"
#include "Input/ControlModuleMapping.h"
#include "ControlModules/ControlModule.h"
#include "ControlModules/UnrealCameraModule.h"
#include "ControlModules/TypingModule.h"
#include "ControlModules/WidgetModule.h"
#include "Widget/WidgetManager.h"
#include "Widget/Widget.h"
#include "Widget/ButtonWidget.h"
#include "Widget/TextFieldWidget.h"
#include "Widget/ListWidget.h"
#include "Canvas.h"
#include "Screen.h"
#include "RenderTools.h"

#ifdef WIN32
#elif defined(__APPLE__) && defined(__MACH__)
#endif

extern InputManager * g_InputManager;

extern TypingModule * g_TypingModuleTEST;		// TODO: Delete this obviously, it's a hack for quick testing purposes

extern Project CurrentProject;

extern int nViewportWidth, nViewportHeight;

#endif // __Main_H__
