#include "Main.h"

void DrawBox(Vector2n Position, Vector2n Size)
{
	DrawBox(Position, Size, Color(1, 1, 1));
}
void DrawBox(Vector2n Position, Vector2n Size, Color BackgroundColor)
{
	DrawBox(Position, Size, BackgroundColor, Color(0.3, 0.3, 0.3));
}
void DrawBox(Vector2n Position, Vector2n Size, Color BackgroundColor, Color BorderColor)
{
	glDisable(GL_TEXTURE_2D);
	
	/*glBegin(GL_LINE_LOOP);
		glColor3d(0.3, 0.3, 0.3);
		glVertex2d(X - 0.5, Y - 0.5);
		glVertex2d(X - 0.5, Y + Height + 0.5);
		glVertex2d(X + Width + 0.5, Y + Height + 0.5);
		glVertex2d(X + Width + 0.5, Y - 0.5);
	glEnd();*/
	glBegin(GL_QUADS);
	glColor3dv(BorderColor.Components.data());
	glVertex2i(-1 + Position.X(), -1 + Position.Y());
	glVertex2i(-1 + Position.X(), +1 + Position.Y() + Size.Y());
	glVertex2i(+1 + Position.X() + Size.X(), +1 + Position.Y() + Size.Y());
	glVertex2i(+1 + Position.X() + Size.X(), -1 + Position.Y());
	glEnd();
	
	glBegin(GL_QUADS);
	glColor3dv(BackgroundColor.Components.data());
	glVertex2i(Position.X(), Position.Y());
	glVertex2i(Position.X(), Position.Y() + Size.Y());
	glVertex2i(Position.X() + Size.X(), Position.Y() + Size.Y());
	glVertex2i(Position.X() + Size.X(), Position.Y());
	glEnd();
	
	glEnable(GL_TEXTURE_2D);
}
void DrawInnerBox(Vector2n Position, Vector2n Size, Color BackgroundColor, Color BorderColor)
{
	glDisable(GL_TEXTURE_2D);
	
	glBegin(GL_QUADS);
	glColor3dv(BorderColor.Components.data());
	glVertex2i(Position.X(), Position.Y());
	glVertex2i(Position.X(), Position.Y() + Size.Y());
	glVertex2i(Position.X() + Size.X(), Position.Y() + Size.Y());
	glVertex2i(Position.X() + Size.X(), Position.Y());
	glEnd();
	
	glBegin(GL_QUADS);
	glColor3dv(BackgroundColor.Components.data());
	glVertex2i(+1 + Position.X(), +1 + Position.Y());
	glVertex2i(+1 + Position.X(), -1 + Position.Y() + Size.Y());
	glVertex2i(-1 + Position.X() + Size.X(), -1 + Position.Y() + Size.Y());
	glVertex2i(-1 + Position.X() + Size.X(), +1 + Position.Y());
	glEnd();

	glColor3d(1, 1, 1);
	glBegin(GL_TRIANGLES);
	glVertex2d(Position.X(), Position.Y());
	glVertex2d(Position.X(), Position.Y() + 1.5);
	glVertex2d(Position.X() + 1.5, Position.Y());
	
	glVertex2d(Position.X() + Size.X(), Position.Y());
	glVertex2d(Position.X() - 1.5 + Size.X(), Position.Y());
	glVertex2d(Position.X() + Size.X(), Position.Y() + 1.5);
	
	glVertex2d(Position.X(), Position.Y() + Size.Y());
	glVertex2d(Position.X() + 1.5, Position.Y() + Size.Y());
	glVertex2d(Position.X(), Position.Y() - 1.5 + Size.Y());
	
	glVertex2d(Position.X() + Size.X(), Position.Y() + Size.Y());
	glVertex2d(Position.X() + Size.X(), Position.Y() - 1.5 + Size.Y());
	glVertex2d(Position.X() - 1.5 + Size.X(), Position.Y() + Size.Y());
	glEnd();
	
	glEnable(GL_TEXTURE_2D);
}
