#pragma once
#ifndef __RenderTools_H__
#define __RenderTools_H__

struct Color
{
	Color(double Red, double Green, double Blue)
	{
		// TODO: Once VC11 gets initializer lists, I can use them...
		Components[0] = Red;
		Components[1] = Green;
		Components[2] = Blue;
	}

	double & operator [] (const uint8 & Index)
	{
		return Components[Index];
	}

	std::array<double, 3> Components;
};

void DrawBox(Vector2n Position, Vector2n Size);
void DrawBox(Vector2n Position, Vector2n Size, Color BackgroundColor);
void DrawBox(Vector2n Position, Vector2n Size, Color BackgroundColor, Color BorderColor);
void DrawInnerBox(Vector2n Position, Vector2n Size, Color BackgroundColor, Color BorderColor);

#endif // __RenderTools_H__
