#pragma once
#ifndef __Screen_H__
#define __Screen_H__

class Screen
{
public:
	Screen(InputManager & InputManager);
	~Screen();
	
	void UpdateWindowDimensions(Vector2n WindowDimensions);

	void Render();

	void ProcessTimePassed(double TimePassed);

private:
	Screen(const Screen &);
	Screen & operator =(const Screen &);

	//std::vector<Canvas>		m_Canvases;
	Canvas MainCanvas;
	Canvas MainCanvas2TEST;
	Canvas OverlayCanvas;

	SystemInputListener SystemInputListener;

	ControlModuleMapping ControlModuleMapping0;
	ControlModuleMapping ControlModuleMapping1;
	WidgetManager WidgetManager;

	WidgetModule WidgetModule;
	UnrealCameraModule UnrealCameraModule;
	class UnrealCameraModule UnrealCameraModule2TEST;
	TypingModule TypingModule;

	InputManager		& m_InputManager;
};

#endif // __Screen_H__
