#include "../Main.h"

ButtonWidget::ButtonWidget(Vector2n Position)
	: Widget(Position)
{
}

ButtonWidget::~ButtonWidget()
{
}

void ButtonWidget::Render(WidgetManager & WidgetManager)
{
	Color BackgroundColor(0.99, 0.99, 0.99);
	Color BorderColor(0.5, 0.5, 0.5);

	if (CheckHover(WidgetManager) && CheckActive(WidgetManager))
	{
		BackgroundColor[0] = 0.5;
		BackgroundColor[1] = 0.5;
		BackgroundColor[2] = 0.5;
		BorderColor[0] = 0.0;
		BorderColor[1] = 0.0;
		BorderColor[2] = 0.0;
	}
	else if ((CheckHover(WidgetManager) && !CheckAnyActive(WidgetManager)) || (!CheckHover(WidgetManager) && CheckActive(WidgetManager)))
	{
		BackgroundColor[0] = 1.0;
		BackgroundColor[1] = 1.0;
		BackgroundColor[2] = 1.0;
		BorderColor[0] = 0.0;
		BorderColor[1] = 0.0;
		BorderColor[2] = 0.0;
	}
	else
	{
	}

	/*glBegin(GL_QUADS);
		glVertex2d(m_Position.X(), m_Position.Y());
		glVertex2d(m_Position.X(), m_Position.Y() + 30);
		glVertex2d(m_Position.X() + 30, m_Position.Y() + 30);
		glVertex2d(m_Position.X() + 30, m_Position.Y());
	glEnd();*/
	DrawBox(m_Position, GetDimensions(), BackgroundColor, BorderColor);
}

Vector2n ButtonWidget::GetDimensions() const
{
	return Vector2n(30, 30);
}
