#include "../Main.h"

Widget::Widget(Vector2n Position)
	: m_Position(Position)
{
}

Widget::~Widget()
{
}

bool Widget::CheckHover(WidgetManager & WidgetManager)
{
	return (this == WidgetManager.m_HoverWidget);
}

bool Widget::CheckActive(WidgetManager & WidgetManager)
{
	return (this == WidgetManager.m_ActiveWidget);
}

bool Widget::CheckAnyActive(WidgetManager & WidgetManager)
{
	return (nullptr != WidgetManager.m_ActiveWidget);
}

void Widget::SetOwnerCanvas(Canvas & OwnerCanvas)
{
	m_OwnerCanvas = &OwnerCanvas;
}

Canvas & Widget::GetOwnerCanvas() const
{
	return *m_OwnerCanvas;
}

bool Widget::HitTest(Vector2d Position) const
{
	auto Dimensions = GetDimensions();

	return ((m_Position.X() - 1 <= Position.X()) && (Position.X() <= m_Position.X() + Dimensions.X() + 1)
			&& (m_Position.Y() - 1 <= Position.Y()) && (Position.Y() <= m_Position.Y() + Dimensions.Y() + 1));
}
