#pragma once
#ifndef __Widget_H__
#define __Widget_H__

class Widget
{
public:
	virtual ~Widget();

	virtual void Render(WidgetManager & WidgetManager) = 0;

	virtual bool HitTest(Vector2d Position) const;
	
	virtual void Clicked() {}

	void SetOwnerCanvas(Canvas & OwnerCanvas);
	Canvas & GetOwnerCanvas() const;

protected:
	Widget(Vector2n Position);

	bool CheckHover(WidgetManager & WidgetManager);
	bool CheckActive(WidgetManager & WidgetManager);
	bool CheckAnyActive(WidgetManager & WidgetManager);

	virtual Vector2n GetDimensions() const = 0;

	Vector2n m_Position;

private:
	Canvas		* m_OwnerCanvas;
};

#endif // __Widget_H__
